/******************************************************************/
/* basic linear algebra routines                                  */
/******************************************************************/
#include <math.h>

/******************************************************************/
/* A * x = y                                                      */
/******************************************************************/
void MatVec(int dof_loc,int *RowPtr,int *KCol,double *matrix_entries,
            double *x,double *y)
{
   int i, j, k, index;
   double s, value;

  j = RowPtr[0];
  for(i=0;i<dof_loc;i++)
  {
    s = 0;
    k = RowPtr[i+1];
    for(;j<k;j++)
    {
      index = KCol[j];
      value = matrix_entries[j];
      s += value * x[index];
    }
    y[i] = s;
  } // endfor i

return;
}

/******************************************************************/
/* d = y - A * x                                                  */
/******************************************************************/
double MatVecDefect(int dof_loc,int *RowPtr,int *KCol,double *matrix_entries,
                  double *x,double *y, double *d)
{
  int i, j, k, index;
  double s, value,res;
  
  res = 0;
  j = RowPtr[0];
  for(i=0;i<dof_loc;i++)
  {
    s = y[i];
    k = RowPtr[i+1];
    for(;j<k;j++)
    {
      index = KCol[j];
      value = matrix_entries[j];
      s -= value * x[index];
    }
    d[i] = s;
    res += s*s;
  } // endfor i
  
  res = sqrt(res);

return(res);
}
