void ComputeNeighbours(int rank, int x_subdoms, int y_subdoms,
                       int *left_neighbour, int *right_neighbour,
                       int *lower_neighbour, int *upper_neighbour);

void LocalLeftLowerCorner(int rank, int x_subdoms, int y_subdoms,
                          double *x, double *y);

void ComputeCoordinates(double x0, double y0, int index, 
                        int x_subdoms, int y_subdoms,  
                        int x_int_loc, int y_int_loc,
                        double *x, double *y);

void ComputeMatrixStructure(int dof_loc, int x_int_loc, int y_int_loc, 
                            int *RowPtr, int *KCol);

void Assemble(int dof_loc, int x_int_loc, int y_int_loc,
              double x0, double y0, int x_subdoms, int y_subdoms,
              double hx, double hy,
              int *RowPtr, int *KCol, double *matrix_entries,
              double *rhs);

void SetDirichletValues(int left_neighbour,int right_neighbour,
                        int lower_neighbour, int upper_neighbour,
                        int x_int_loc, int y_int_loc,
                        int x_subdoms, int y_subdoms,
                        double x0, double y0,
                        int *RowPtr, int *KCol, double *matrix_entries,
                        double *sol, double * rhs);

void MatVec(int dof_loc,int *RowPtr,int *KCol,double *matrix_entries,
            double *x,double *y);

double MatVecDefect(int dof_loc,int *RowPtr,int *KCol,double *matrix_entries,
                  double *x,double *y, double *d);

void  MakeVectorConsistent(int left_neighbour,int right_neighbour,
                           int lower_neighbour,int upper_neighbour,
                           int x_int_loc,int  y_int_loc, double *vec);

double RightHandSide(double x,double y);
double BoundCond(double x,double y);
double Solution(double x,double y);
void jacobi(int rank,
	    int left_neighbour,int right_neighbour,
	    int lower_neighbour,int upper_neighbour,
	    int x_int_loc,int  y_int_loc,
	    int maxit, double eps, double damp,
	    int dof_loc, int *KCol, int *RowPtr,
	    double *matrix_entries, double *sol, double *rhs,
	    double *defect);
void sor(int rank,
         int left_neighbour,int right_neighbour,
         int lower_neighbour,int upper_neighbour,
         int x_int_loc,int  y_int_loc,
         int maxit, double eps, double damp,
         int dof_loc, int *KCol, int *RowPtr,
         double *matrix_entries, double *sol, double *rhs,
         double *defect);
void ssor(int rank,
          int left_neighbour,int right_neighbour,
          int lower_neighbour,int upper_neighbour,
          int x_int_loc,int  y_int_loc,
          int maxit, double eps, double damp,
          int dof_loc, int *KCol, int *RowPtr,
          double *matrix_entries, double *sol, double *rhs,
          double *defect);
void cg(int rank,
        int left_neighbour,int right_neighbour,
        int lower_neighbour,int upper_neighbour,
        int x_int_loc,int  y_int_loc,
        int maxit, double eps, double damp,
        int dof_loc, int *KCol, int *RowPtr,
        double *matrix_entries, double *sol, double *rhs,
        double *defect);
void pcg(int rank,
         int left_neighbour,int right_neighbour,
         int lower_neighbour,int upper_neighbour,
         int x_int_loc,int  y_int_loc,
         int maxit, double eps, double damp,
         int dof_loc, int *KCol, int *RowPtr,
         double *matrix_entries, double *sol, double *rhs,
         double *defect);
