void ComputeMatrixStructure(int dof_loc, int x_int_loc, int y_int_loc, 
                            int *RowPtr, int *KCol)
{
  int i, n, ii, jj, kk, ind[3], index, start, ind_row, ind_col, nx;
  int skip;
  nx = x_int_loc+1;

  /* initialize column array */
  for (i=0;i<7*dof_loc; i++)
    KCol[i] = -1;

  /* initialize row ptr array */
  for (i=0;i<=dof_loc; i++)
    RowPtr[i] = 7*i;
  
  /* loop over all rectangles containing two triangles */
  n = 2*x_int_loc * y_int_loc;
  index = -2;
  for (i=0;i<n; i++)
  {
    /* first triangel, left lower */
    if ((i%2)==0)
    {
      index++;
      if (((i/2) % x_int_loc)== 0)
        index++;
      /*printf("%d \n",index);*/
      ind[0] = index;
      ind[1] = index+nx;
      ind[2] = index+nx+1;
    }
    else
    /* second triangel, right upper */
    {
      ind[0] = index;
      ind[2] = index+nx+1;
      ind[1] = index+1;
    }
    /* test all pairs of indizes if they are already
       contained in the matrix structure */
    for (ii=0;ii<3;ii++)
    {
      ind_row = ind[ii];
      for (jj=0;jj<3;jj++)
      {
        ind_col = ind[jj];
        start = RowPtr[ind[ii]];
        for (kk = 0; kk<7;kk++)
        {
           /* column already in KCol */  
          if ((KCol[start+kk])==ind_col)
             break;
          /* new column */
          if ((KCol[start+kk])==-1)
          {
             KCol[start+kk] = ind_col;
             break;
          }
        }
          
      }    
    }   
  }

  /* dense matrix structure */
  /* compute how many entries are in each row */
  skip = 0; 
  for (i=0;i<dof_loc; i++)
  {
    start = 7*i; 
    for (ii=0;ii<7;ii++)
    {
      /* no column entry */ 
      if (KCol[start+ii]==-1)  
        skip++;
    }
    RowPtr[i+1] -= skip;
  }

  /* dense the column array */
  for (i=0;i<dof_loc; i++)
  {
     start = RowPtr[i];
     index = start;
     for (ii=7*i;ii<7*(i+1);ii++)
     {
       if (KCol[ii]!=-1)
       {
          KCol[index] = KCol[ii];
          index++;
       }
     }
  }
  return;
}
